package com.zipcodewilmington.singlylinkedlist;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList<E> implements Cloneable{
    private Node<E> head;
    private Node<E> tail;
    private int size = 0;

    public Integer size() {
        return size;
    }

    public void add(E e) {
        Node<E> current = head;
        final Node<E> newNode = new Node<>(e);

        if(head == null){
            head = newNode;
            size++;
        } else {
            while (current.next != null){
                current = current.next;
            }
            current.next = newNode;
            size++;
        }
    }

    public void addFirst(E e) {
        final Node<E> h = head;
        final Node<E> newNode = new Node<>(e);
        head = newNode;
        if (h == null)
            tail = newNode;
        else
            head.next = h;
        size++;
    }

    public void addAt(E e, int idx) {
        int i = 0;
        Node<E> current = head;
        while (i < idx-1) {
            current = current.next;
            i++;
        }

        final Node<E> newNode = new Node<>(e);
        newNode.next = current.next;
        current.next = newNode;
        size++;
    }

    public boolean contains(E e) {
        Node<E> current = head;
        while(current != null){
            if (current.element.equals(e)) return true;
            current = current.next;
        }
        return false;
    }

    public Integer find(E e) {
        int i = 0;
        Node<E> current = head;
        if (contains(e)) {
            while (current.next != null) {
                current = current.next;
                i++;
                if (current.element.equals(e)) break;
            }
        } else {
            i = -1;
        }
        return i;
    }

    public E getElement(int idx) {
        E result = null;
        if (size >= idx) {
            Node<E> current = head;
            int i = 0;
            while (i < idx) {
                current = current.next;
                i++;
            }
            result = current.element;
        }
        return result;
    }

    public SinglyLinkedList<E> copy() throws CloneNotSupportedException{
        return clone();
    }

    public void sort() {
        E[] array = (E[]) new Object[size()];
        for (int i = 0; i < size(); i++) {
            array[i] = getElement(i);
        }

        E current = array[0];
        for (int j = 1; j < array.length; j++) {
            if (String.valueOf(array[j]).compareTo(String.valueOf(current)) < 0) {
                current = array[j];
                array[j] = array[j - 1];
                array[j - 1] = current;
                for (int k = j - 1; k > 0; k--) {
                    if (String.valueOf(array[k]).compareTo(String.valueOf(array[k - 1])) < 0) {
                        current = array[k];
                        array[k] = array[k - 1];
                        array[k - 1] = current;
                    }
                }
            }
        }

        Node<E> curr = head;
        for (int x = 0; x < size(); x++) {
            curr.element = (array[x]);
            curr = curr.next;
        }
    }

    protected SinglyLinkedList<E> clone() throws CloneNotSupportedException {
        SinglyLinkedList<E> newList = (SinglyLinkedList<E>) super.clone();
        newList.head = head.clone();
        return newList;
    }

    private static class Node<E> implements Cloneable{
        E element;
        Node<E> next;

        Node(E element) {
            this.element = element;
        }

        protected Node<E> clone() throws CloneNotSupportedException{
            return (Node<E>) super.clone();
        }
    }
}