package com.zipcodewilmington.singlylinkedlist;

import org.junit.Assert;
import org.junit.Test;

/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedListTest {
    SinglyLinkedList<String> list = new SinglyLinkedList<>();

    @Test
    public void addTest(){
        list.add("Hello");
        Integer actual = list.size();
        Integer expected = 1;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getElementTest(){
        list.add("Hello");
        list.add("Zip Code");
        String actual = list.getElement(0);
        String expected = "Hello";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void getElementTest2(){
        list.add("Hello");
        list.add("Zip Code");
        list.add("Wilmington");
        String actual = list.getElement(1);
        String expected = "Zip Code";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void addFirstTest(){
        list.add("Hello");
        list.add("Zip Code");
        list.addFirst("Uhhhh");
        String actual = list.getElement(0);
        String expected = "Uhhhh";

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void addAtTest(){
        list.add("Hello");
        list.add("Zip Code");
        list.add("Wilmington");
        list.addAt("To",2);
        String actual = list.getElement(2);
        String expected = "To";

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void containsTest(){
        list.add("Hello");
        list.add("Zip Code");
        list.add("Wilmington");

        Boolean actual = list.contains("Wilmington");
        Assert.assertTrue(actual);
    }

    @Test
    public void findTest(){
        list.add("Hello");
        list.add("Zip Code");
        list.add("Wilmington");

        Integer actual = list.find("Zip Code");
        Integer expected = 1;

        Assert.assertEquals(expected,actual);
    }

    @Test
    public void copyTest() throws CloneNotSupportedException {
        list.add("Hello");
        list.add("Zip Code");
        list.add("Wilmington");
        SinglyLinkedList<String> test = list.copy();

        String actual = test.getElement(0);
        String expected = "Hello";
        Assert.assertEquals(expected,actual);
    }

    @Test
    public void sortTest(){
        list.add("Hello");
        list.add("Breakfast");
        list.add("Apple");

        list.sort();
        Assert.assertEquals("Apple",list.getElement(0));
    }

    @Test
    public void sortTest2(){
        list.add("Hello");
        list.add("Breakfast");
        list.add("Apple");

        list.sort();
        Assert.assertEquals("Breakfast",list.getElement(1));
    }

    @Test
    public void sortTestInts(){
        SinglyLinkedList<Integer> list2 = new SinglyLinkedList<>();
        list2.add(5);
        list2.add(3);
        list2.add(1);

        list2.sort();
        Integer expected = 1;
        Integer actual = list2.getElement(0);
        Assert.assertEquals(expected,actual);
    }

}
